# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import gtk
import webbrowser

class Link( gtk.EventBox ):
    
    def __init__( self, text, url, font=None, size=None ):
        
        gtk.EventBox.__init__( self )
    
        self.set_events(gtk.gdk.BUTTON_PRESS_MASK)
        fontspan = ''
        
        if font != None:
            fontspan = 'font_family="' + font + '" '
            
        if size != None:
            fontspan = 'size="' + str( size ) + '"'
            
        self.text = '<u><span foreground="#0000AA" ' + fontspan + '>' + text + '</span></u>'
        self.url = url
        
        self.label = gtk.Label( self.text )
        self.label.set_use_markup( True )
        style = self.get_style().copy()
        style.bg[gtk.STATE_NORMAL] = self.get_style().white
        self.set_style( style )
        
        self.add( self.label )
        
        self.connect( 'button_press_event', self.on_link_clicked )
        
    def on_link_clicked( self, *args ):
        if webbrowser._iscommand("firefox"):
            webbrowser.register("firefox", None, webbrowser.Netscape("firefox"))
        webbrowser.open( self.url, 2 )
        
if __name__ == '__main__':
    import sys

    def quit( *args ):
        sys.exit( 0 )

    w = gtk.Window()
    w.set_default_size( 100, 100 )
    w.connect( 'delete-event', quit )
    w.add( Link( 'google', 'www.google.com'  ) )
    w.show_all()
    gtk.main()
