# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import os
import shutil

class Log( object ):
    '''
    this class represent a log instance (a log of a conversation)
    '''

    def __init__( self, theme, path, filename ):
        '''
        Contructor
        '''

        self.log = '<html><body>'

        self.path = path
        self.filename = filename

        self.theme = theme

        self.smilies = [] # a list of the smilies that we need to copy

    def add( self, text, style ):
        '''add text to the log'''
        t = ''

        for i in self.process( [ text ] , self.theme.getSmileysList() ):
            if i in self.theme.getSmileysList():

                if not ( i in self.smilies ):
                    self.smilies.append( i )
            
            if i in self.theme.getSmileysList():
                t += '<img src="' + self.filename + '_files/' + os.path.split( self.theme.smilieToPath[ i ] )[ 1 ] + '"/>'
            else:
                t += i
                
        self.log += '<span style="' + style + '">' + t + '</span>'

    def save( self ):
        '''
        save the file to the given path + filename
        return True on success
        '''
    
        location = os.path.join( self.path, self.filename )
        imgLocation = os.path.join( self.path, self.filename + '_files' )
        try:
            try:
                os.mkdir( imgLocation )
            except:
                pass
            
            fd = file( location + '.html' , 'w' )
            fd.write( self.log + '</body></html>')
            fd.close()

# TODO: need to be worked out. Anyway, do we need image smileys in a log??
# maybe we just could leave text and put images when presenting it
#            for i in self.smilies:
#                shutil.copy( self.theme.smilieToPath[ i ], imgLocation )
        except Exception, e:
            print e
            return False

        return True

    def process( self , list , smilies ):
        '''
        create a list of text and smilies like
        [ 'hi, mi name is ', ':)' , ' pepe' ]
        '''
        
        if smilies == []:
            return list
    
        newlist = []
    
        for i in list:
            for j in i.split( smilies[ 0 ] ):
                newlist += [ j ]
                newlist += [ smilies[ 0 ] ]
                
            newlist = newlist[ :-1 ]

        return self.process( newlist , smilies[ 1: ] )

if __name__ == '__main__':
    import Theme

    theme = Theme.Theme( 'default' )
    l = Log( theme, '/home/mariano/.config/emesene1.0/', 'test' )
    l.add( 'hola :D' )
    l.save()
