# -*- coding: utf-8 -*-

#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

class SlashCommands:
    def __init__( self ):
        self.commands = {}
        self.register( 'help', self.slashHelp )
        
    def register( self, command, callback, help=None ):
        if not self.commands.has_key( command ):
            self.commands[command] = [callback, help]
        else:
            print 'El comando', command,'ya lo registraron.. mas suerte la proxima ;)'
        
    def unregister( self, command ):
        if self.commands.has_key( command ):
            self.commands.pop( command )
        
    def getCommands( self ):
        return ', '.join(self.commands.keys())

    def getCommandHelp( self, command ):
        if self.commands.has_key(command):
            if self.commands[command][1] != None:
                return self.commands[command][1]
            else:
                return 'El comando '+command+ ' no tiene ayuda'
        else:
            return 'El comando '+ command + ' no existe'
        
    def emit( self, conversation, command ):
        tmp = command[1:].split(" ",1)
        if( len( tmp ) > 1 ):
            if self.commands.has_key( tmp[0] ):
                message = self.commands[ tmp[0] ][0]( tmp[1] )
            else:
                message = ['El comando no existe', False]
        elif( len( tmp ) == 1 ):
            if self.commands.has_key( tmp[0] ):
                message = self.commands[ tmp[0] ][0]()
            else:
                message = ['El comando no existe', False]
        elif ( len(tmp) ) == 0:
            message = ['el comando fallo...', False]
        if message[1] == True:
            conversation.sendMessage(message[0])
            return True
        else:
            conversation.appendOutputText( conversation.window.user, message[0] + '\n', conversation.getCssStyle(), 'font-weight: bold; color: black' )
            return True
            
            
    def slashHelp( self, data=None ):
        if( data != None ):
            return [ self.getCommandHelp( data ),  False]
        else:
            text = _('Utilice "/help <orden>" para obtener ayuda de una acción.\n')
            text += _('Las siguientes acciones están disponibles:\n')
            text += self.getCommands()
            return [text, False]