#   This file is part of emesene.
#
#    Emesene is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    emesene is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with emesene; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

# Right now we are not using gtk themes facilities
#
# We should consider using them at some point

import os
import gtk.gdk

from emesenecommon import *
#echo -e '\t'self.smilieToPath = {\\\n;for i in $( ls ); do echo -e '\t\t'\'\' : path + \'smilies/$i\',\\;done;echo -e '\n\t'}

ALTERNATIVE_SMILEYS = {\
    '(a)' : [ '(A)' ],\
    ':@' : [ ':-@' ],\
    '(b)' : [ '(B)' ] ,\
    '(z)' : [ '(Z)' ] ,\
    '(u)' : [ '(U)' ] ,\
    '(p)' : [ '(P)' ] ,\
    '(o)' : [ '(O)' ] ,\
    '(c)' : [ '(C)' ] ,\
    ':s' : [ ':S', ':-S' ] ,\
    ':|' : [ ':-|' ] ,\
    '(d)' : [ '(D)' ] ,\
    '(e)' : [ '(E)' ] ,\
    ':$' : [ ':-$' ] ,\
    '(g)' : [ '(G)' ] ,\
    '(x)' : [ '(X)' ] ,\
    '(h)' : [ '(H)' ] ,\
    '(i)' : [ '(I)' ] ,\
    '(m)' : [ '(M)' ] ,\
    ':D' : [ ':d', ':-d', ':-D' ] ,\
    '(l)' : [ '(L)' ] ,\
    '(k)' : [ '(K)' ] ,\
    '(f)' : [ '(F)' ] ,\
    ':(' : [ ':-(' ] ,\
    ':)' : [ ':-)' ] ,\
    ':p' : [ ':P', ':-P' ] ,\
    ':-O' : [ ':O', ':o', ':-o' ] ,\
    '(t)' : [ '(T)' ] ,\
    '(n)' : [ '(N)' ] ,\
    '(y)' : [ '(Y)' ] ,\
    '(w)' : [ '(W)' ] ,\
    ';)' : [ ';-)' ] ,\
    '(r)' : [ '(R)' ],\
}


SMILEY_TO_NAME = {\
    '<:o)' : 'party_smiley',\
    '(ap)' : 'Airplane',\
    '(a)' : 'angel',\
    ':@' : 'angry',\
    '(au)' : 'Auto',\
    '8o|' : 'Baring_teeth_smiley',\
    '(b)' : 'beer',\
    #'Be_Right_Back' : 'Be_Right_Back.gif',\
    '(^)' : 'Birthday_cake',\
    '(bah)' : 'Black_sheep',\
    '(nah)' : 'goat',\
    '(||)' : 'Bowl',\
    '(z)' : 'Boy',\
    '(u)' : 'brheart',\
    '(p)' : 'photo',\
    '(@)' : 'pussy',\
    '(ci)' : 'Cigarette',\
    '(o)' : 'Clock',\
    '(c)' : 'coffee',\
    '(co)' : 'computer',\
    ':s' : 'confused',\
    ':\'(' : 'cry',\
    '(6)' : 'devil',\
    ':|' : 'stare',\
    '(&)' : 'Dog_face',\
    ':-#' : 'Dont_tell_anyone',\
    '(d)' : 'drink',\
    '(e)' : 'mail',\
    ':$' : 'blushing',\
    '8-)' : 'Eye_rolling_smiley',\
    '(~)' : 'video-x-generic',\
    '(yn)' : 'Fingerscrossed',\
    '(g)' : 'Gift_with_a_bow.',\
    '(x)' : 'Girl',\
    '(%)' : 'cuffs',\
    '(h5)' : 'Hi_five',\
    '(h)' : 'coolglasses',\
    ':^)' : 'andy',\
    '(ip)' : 'Island_with_a_palm_tree',\
    '({)' : 'hugleft',\
    '(i)' : 'lamp',\
    '(li)' : 'weather-storm',\
    '(m)' : 'Messenger',\
    '(mp)' : 'phone',\
    '(mo)' : 'Money',\
    '8-|' : 'face-glasses',\
    '(8)' : 'audio-x-generic',\
    ':D' : 'grin',\
    '(pi)' : 'Pizza',\
    '(pl)' : 'Plate',\
    '(r)' : 'rainbow',\
    '(st)' : 'weather-showers-scattered',\
    '(l)' : 'emblem-favorite',\
    '(K)' : 'kiss',\
    '(f)' : 'flower',\
    '(})' : 'hugright',\
    ':(' : 'unhappy',\
    '^o)' : 'Sarcastic_smiley',\
    ':-*' : 'Secret_telling_smiley',\
    '+o(' : 'sick',\
    '(S)' : 'weather-clear-night',\
    '|-)' : 'sleeping',\
    ':)' : 'smile',\
    ':p' : 'tongue',\
    '(sn)' : 'Snail',\
    '(so)' : 'Soccer_ball',\
    '(*)' : 'star',\
    '(#)' : 'weather-clear',\
    ':-O' : 'oh',\
    '(t)' : 'Telephone_receiver',\
    '*-)' : 'Thinking_smiley',\
    '(n)' : 'thumbdown',\
    '(y)' : 'thumbup',\
    '(tu)' : 'Turtle',\
    '(um)' : 'Umbrella',\
    ':[' : 'bat',\
    ':-[' : 'bat',\
    '(w)' : 'brflower',\
    ';)' : 'wink',\
    '(xx)' : 'Xbox',\
}

ACCEPTED_FORMATS = [ 'png', 'gif', 'svg', 'xpm' ]

class Theme:
    '''
    This class contains all the data related to a theme:
    images, icons, animations, path to sounds etc
    '''
    
    def __init__( self , name=None ):
        '''
        Constructor
        '''
        
        self.defaults = {}
        self.pixbufs = {}
        
        if name:
            self.setTheme( name )
        else:
            self.path = DEFAULT_THEME_PATH
        self.tracee = 1
        # sets up a dict with the differnt smiley shortcodes
        # that translates to smileys names
        self.smileyToName = {}
        for (key,value) in SMILEY_TO_NAME.iteritems():
            self.smileyToName[ key ] = value
            
            if key in ALTERNATIVE_SMILEYS:
                for i in ALTERNATIVE_SMILEYS[ key ]:
                    self.smileyToName[ i ] = value
    
    def setTheme( self, name ):
        '''
        Sets the current theme to the name given.
        In case of error, it will directly fallback to the default theme
        Returns True if the specified theme was correctly set, otherwise
        False
        '''
        
        if name == 'default':
            self.pixbufs = self.defaults
            self.path = DEFAULT_THEME_PATH
            return True
        else:
            self.pixbufs = {}
        
        path = None
        if os.path.isdir( THEME_HOME_PATH + DIR_SEP + name ):
            path = THEME_HOME_PATH + DIR_SEP + name + DIR_SEP
        elif os.path.isdir( THEME_SYSTEM_WIDE_PATH + DIR_SEP + name ):
            path = THEME_SYSTEM_WIDE_PATH + DIR_SEP + name + DIR_SEP
        else:
            debugmsg( 'Theme '+ name + \
                      ' couldn\'t be found where it was supposed to be', 2 )
            debugmsg( 'Falling back to the default theme' )
        
        if path:    
            self.path = path
            return True
        else:
            self.path = DEFAULT_THEME_PATH
            return False
 
    def getImage( self, name, animated=False, subpath=None ):
        '''
        Returns a pixbuf of the requested image from the current theme
        If the requested image name is not found in the current theme, the
        default theme's corresponding image will be returned.
        If the default theme doesn't have such a image, None is returned
        '''
        
        # checks if already loaded
        if name in self.pixbufs:
            return self.pixbufs[ name ]
        
        # determines which pixbuf function is used to create it
        pixbufCreator = gtk.gdk.pixbuf_new_from_file
        if animated:
            pixbufCreator = gtk.gdk.PixbufAnimation
                
        def searchPixbuf( path ):
            if not path.endswith( DIR_SEP ):
                path = path + DIR_SEP
            if subpath:
                path = path + subpath + DIR_SEP
            for i in ACCEPTED_FORMATS:
                try:
                    pixbuf = pixbufCreator( path + name + '.' + i )
                    return pixbuf
                except:
                    pass
            return None
        
        pixbuf = searchPixbuf( self.path )
        if pixbuf:
            # returns icon from theme
            self.pixbufs[ name ] = pixbuf
            return pixbuf
        else:
            # will return icon from default theme
            if name in self.defaults:
                return self.defaults[ name ]
            else:
                self.defaults[ name ] = searchPixbuf( DEFAULT_THEME_PATH )
                return self.defaults[ name ]
                
    def getImageIcon( self, name, animated=False, subpath=None ):
        '''
        Returns a pixbuf of the requested image from the current theme
        If the requested image name is not found in the current theme, the
        default theme's corresponding image will be returned.
        If the default theme doesn't have such a image, None is returned
        '''

        
        def searchLocation( path ):
            if not path.endswith( DIR_SEP ):
                path = path + DIR_SEP
            if subpath:
                path = path + subpath + DIR_SEP
                
            for i in ACCEPTED_FORMATS:
                location=path+name+'.'+i 
                if os.path.exists(location):
                    return location

        
        location = searchLocation( self.path )
        if location:
            # returns icon from theme
            return location
        else:
            # will return icon from default theme
            return searchLocation( DEFAULT_THEME_PATH )

    def getSmiley( self, shortcode ):
        '''
        Returns a pixbuf representing the corresponding smiley if we have one,
        otherwise None
        '''
            
        if shortcode in self.smileyToName:
            return self.getImage( self.smileyToName[ shortcode ], True, 'smilies')
            
            
            
    def getSmileyPath( self, shortcode ):
        '''
        Returns a pixbuf representing the corresponding smiley if we have one,
        otherwise None
        '''
        
        if shortcode in self.smileyToName:
            return self.getImageIcon( self.smileyToName[ shortcode ], True, 'smilies')
            
        
    def statusToPixbuf( self, status ):
        '''
        Translates a status code in a pixbuf returning the according
        theme image
        '''
    
        name = None
        if status == 'NLN' or status == 'online':
            name = 'online'
        elif status == 'AWY' or status == 'away':
            name = 'away'
        elif status == 'BSY' or status == 'busy':
            name = 'busy'
        elif status == 'BRB' or status == 'brb':
            name = 'brb'
        elif status == 'PHN' or status == 'phone':
            name = 'phone'
        elif status == 'LUN' or status == 'lunch':
            name = 'lunch'
        elif status == 'HDN' or status == 'invisible':
            name = 'invisible'
        elif status == 'IDL' or status == 'idle':
            name = 'idle'
        elif status == 'FLN' or status == 'offline':
            name = 'offline'

        if name:
            return self.getImage( name )
        else:
            return None
       
    def getBlockedImage( self, pixbuf ):
        '''
        Returns a new pixbuf with a composition of the given pixbuf and the
        theme's block image
        '''
        pixbuf = pixbuf.copy()
        blocked = self.getImage( 'blocked' )
        if blocked:
            blocked.composite( pixbuf, 0, 0, pixbuf.props.width, \
                          pixbuf.props.height, 0, 0, 1.0, 1.0, \
                          gtk.gdk.INTERP_HYPER, 255)
            return pixbuf
        else:
            # this is the unlikely case when there's no blocked image in
            # neither the current nor the default theme
            return pixbuf
        
    def getSound( self, name ):
        '''
        Returns the sound file path according to the current theme, or the
        corresponding default sound if the current theme doesn't provide
        such a file.
        Returns None if the sound file can't be found in neither the current
        nor the default theme
        '''
        
        path = self.path + "sounds" + DIR_SEP + name + ".wav"
        if os.path.exists( path ):
            return path
        
        # Tries with default theme
        path = DEFAULT_THEME_PATH + "sounds" + DIR_SEP + name + ".wav"
        if os.path.exists( path ):
            return path
        else:
            # no sound file can be found for the given name
            return None
        
    def getSmileysList( self ):
        '''
        Returns a list of all the currently accepted smileys shortcodes
        '''
        
        return self.smileyToName.keys()
    
    def getSingleSmileysList( self ):
        '''
        Returns a list of the currently accepted smileys shortcodes, without
        repetitions
        '''
        
        return SMILEY_TO_NAME.keys()
        
    def getUserDisplayPicture( self, email ):
        '''return a pixbuf with the display picture of the user
        or the default image if not found'''
        
        user = email.split( '@' )[ 0 ]
        imagePath = CACHE_PATH + os.sep + user + '.tmp'
        
        if os.path.exists( imagePath ) \
        and os.path.isfile( imagePath ):
            try:
                pixbuf = gtk.gdk.pixbuf_new_from_file( imagePath )
            except:
                pixbuf = self.getImage( 'login' )
        else:
            pixbuf = self.getImage( 'login' )
            
        return self.resizePixbuf(pixbuf, 98, 98)
    
    def resizePixbuf( self,pixbuf, height, width ):
        pWidth, pHeight = pixbuf.get_width(), pixbuf.get_height()        
        destX = destY = 0
        destWidth, destHeight = width, height
        if pWidth > pHeight:
            scale = float( width ) / pWidth
            destHeight = int( scale * pHeight )
            destY = int( ( height - scale * pHeight ) / 2 )
        elif pHeight > pWidth:
            scale = float( height ) / pHeight
            destWidth = int( scale * pWidth )
            destX = int( ( width - scale * pWidth ) / 2 )
        else:
            return pixbuf.scale_simple( width, height, gtk.gdk.INTERP_HYPER )
        
        if scale == 1:
            return pixbuf
        
        scaled = gtk.gdk.Pixbuf( gtk.gdk.COLORSPACE_RGB, True, 8, width, height)
        pixbuf.scale( scaled, 0, 0, width, height, \
                      destX, destY, scale, scale, \
                      gtk.gdk.INTERP_HYPER )
        return scaled